var heuristicXMLtemplate = '<?xml version="1.0"?>' + '<uzreviewdata>' + '<project name=""/>' + '</uzreviewdata>';

// Load existing review projects
// Populates widget project-selector
function uzPopulateSelector() {
  debugDump("\n\nuzReview Init\n");
  if(!inited) {
    inited = true;
	// Populate list of projects
    var selector = document.getElementById("project-selector");
    var du=new DirUtils(); 
    var tempCat, tempCatName;
    var tempNode, tempLabel;
    var dataPath = du.getChromeDir() + fileSeparator + 'uzreview' + fileSeparator + 'content' + fileSeparator + 'projects' + fileSeparator;
    var dataFolder = new Dir(dataPath);
    debugDump("Found datafile? " + dataPath + " "+ dataFolder.exists() + "\n");
    var xmlDir = dataFolder.readDir();
    for(var i=0;i<xmlDir.length;i++) {
			// Don't populate the from the notes field.
			if(xmlDir[i].path.indexOf(".xml") > -1) {
	      tempNode = document.createElement("listitem");
	      tempLabel = xmlDir[i].path.replace(".xml", "");
	      tempLabel = tempLabel.replace(dataPath, "");
	      tempNode.setAttribute( "label",tempLabel);
	      tempNode.setAttribute("path", xmlDir[i].path);
	      selector.appendChild(tempNode);
			}
    }  
    debugDump("Done loading project definitions\n");
  }
  debugDump("Ending uzPopulateSelector();");
}


// Load heuristics file
// Future functionality will allow a choice of heuristic files
// Called upon window opening
function heuristicsInit() {
  debugDump("\n\n*** Loading heuristics from xml. \n");
  var du=new DirUtils(); 
  var tempCat, tempCatName;
  var tempNode, tempLabel;
  var dataPath = du.getChromeDir() + '\\uzreview\\content\\heuristics\\' + document.getElementById("heuristic_set").selectedItem.getAttribute("file") + ".xml";
  var dataFile = new File(dataPath);
  debugDump("Found datafile? " + dataPath + " "+ dataFile.exists() + "\n");
  dataFile.open("r");
  var heuristicXMLfile = dataFile.read();
  dataFile.close;
  // Object for UI population of heuristics
  heuristicsXML =  new DOMParser().parseFromString(heuristicXMLfile, "text/xml");	
 // debugDump("closing file\n");
  // Object for user data
  xHeuristics = new DOMParser().parseFromString(heuristicXMLtemplate, "text/xml");

	deleteAllChilds(document.getElementById("heuristic-holder"));
  populateHeuristicsForm(heuristicsXML);

  debugDump("*** Heuristics initialized & review data obj constructed. \n");
}




// Launch a new Review 
function heuristicStartNewReview() {
  var temp;
	browserHandle = getBrowser(); //getBrowser();
 
  debugDump("Got browser = " + browserHandle + "\n");
  deleteAllChilds(document.getElementById("project-selector"));
	deleteAllChilds(document.getElementById("view-page-holder"));
	deleteAllChilds(document.getElementById("view-heuristic-holder"));
	document.getElementById('edit-box').contentWindow.document.body.innerHTML = '';
	//document.getElementById("id_keyword").selected = "false";	
	//document.getElementById("id_url").selected = "true";
	document.getElementById("uzMode").selectedItem = document.getElementById("id_url");
	reviewStarted = true;
  addPageChangeListener();

	 
   debugDump("starting review " + document.getElementById('heuristic_project_name') + " " + document.getElementById('heuristic_project_name').value + "\n")
   document.getElementById('heuristicTopDeck').selectedIndex=1;
   document.getElementById('heuristic_name').setAttribute('value', document.getElementById('heuristic_project_name').value);
		document.getElementById("heuristic_keyword").value = "";
  //document.getElementById('heuristic_project_owner').value = uzillaPrefs.review.defaultOwner;
  curLoc = browserHandle.contentDocument.location.href;

 	heuristicsInit();
	setProjectInfo(xHeuristics);
	// Need to init widget at startup
  // urDoPageChange(false);
	urDoPageChange(curLoc);
}

function setProjectInfo(xml) {
	var projectnode = xml.getElementsByTagName("project").item(0);
	projectnode.setAttribute("name", document.getElementById('heuristic_project_name').value);
	projectnode.setAttribute("owner", document.getElementById('heuristic_project_owner').value);
	projectnode.setAttribute("heuristicset", document.getElementById("heuristic_set").selectedItem.getAttribute("file"));
	
}
 
function addPageChangeListener() {
 	if (!gBrowser.mTabbedMode) gBrowser.enterTabbedMode();
  browserHandle = getBrowser(); //getBrowser();
  debugDump("Got browser = " + browserHandle + "\n");
  reviewStarted = true;
  initProgressListener();
  getBrowser().addProgressListener(urProgressListener);
}

 // NOT USED 07/03
function updateSession() {
   debugDump("Updating session.");
   urlmode = document.getElementById("id_url");
  keywordmode = document.getElementById("id_keyword");
  dataframe=document.getElementById("dataFrame").contentDocument;
 }
 
function populateKeywordMenu(xml) {
	debugDump("Writing keyword menuitems \n");
	var keywords = xml.getElementsByTagName("keyword");
	var keywordMenuList = document.getElementById("heuristic_keyword").childNodes.item(0);
	debugDump(" to " + keywordMenuList.nodeName + "\n");
	var tempNode;
	deleteAllChilds(keywordMenuList);
	for(var i=0;i<keywords.length;i++) {
		tempNode = document.createElement("menuitem");
		tempNode.setAttribute("label", keywords.item(i).getAttribute("id"));
		keywordMenuList.appendChild(tempNode);
	}
}


